-- Global variables:
	-- Version:
local version = "1.1"

	-- Colors:
local cGold = "|cFF0070DE"
local cPurple = "|cFFF900F9"
local cWhite = "|cFFFFFFFF"
local cRed = "|cFFFF0000"
local cGreen = "|cFF00FF00"

	-- Constants:
local CRITS_DMG = 1
local CRITS_HEAL = 2
local CRITS_DMG2 = 3
local CRITS_HEAL2 = 4
local CRITS_BAN1 = 98
local CRITS_BAN2 = 99

	-- Other:
local PlayerEvent = CreateFrame("Frame")
local CombatLogEvent = CreateFrame("Frame")
local prefix = cPurple .. "[CritZ] " .. cGold
local char_name = nil
local MyFrame = nil
local boot = false
local banmode = false



-- Preform events
function Update_Crits()
	local spec = GetActiveSpecGroup()
	local currentSpec = GetSpecialization()
	local sname = currentSpec and select(2, GetSpecializationInfo(currentSpec)) or "None"
	local damagecrits = cPurple .. "\n\n\nDamage:" .. cGold
	local healcrits = cPurple .. "\n\n\nHealing:" .. cGold
	
	if (spec == 1) then
		if (not next(LediiData[char_name][CRITS_DMG])) then
			damagecrits = ""
		end
		if (not next(LediiData[char_name][CRITS_HEAL])) then
			healcrits = ""
		end
		
		for key, value in pairs(LediiData[char_name][CRITS_DMG]) do
			damagecrits = damagecrits .. "\n\n" .. cWhite .. key .. cGold .. " - " .. cRed .. value .. cGold
		end
		for key, value in pairs(LediiData[char_name][CRITS_HEAL]) do
			healcrits = healcrits .. "\n\n" .. cWhite .. key .. cGold .. " - " .. cGreen .. value .. cGold
		end
	else
		if (not next(LediiData[char_name][CRITS_DMG2])) then
			damagecrits = ""
		end
		if (not next(LediiData[char_name][CRITS_HEAL2])) then
			healcrits = ""
		end
		
		for key, value in pairs(LediiData[char_name][CRITS_DMG2]) do
			damagecrits = damagecrits .. "\n\n" .. cWhite .. key .. cGold .. " - " .. cRed .. value .. cGold
		end
		for key, value in pairs(LediiData[char_name][CRITS_HEAL2]) do
			healcrits = healcrits .. "\n\n" .. cWhite .. key .. cGold .. " - " .. cGreen .. value .. cGold
		end

	end
	
	MyFrame.text:SetText(cGold .. "Specialization: " .. sname .. damagecrits .. healcrits)
end

function Update_Bans()
	local spec = GetActiveSpecGroup()
	local bancrits = cPurple .. "Banned:" .. cGold
	
	if (spec == 1) then

		for key, value in pairs(LediiData[char_name][CRITS_BAN1]) do
			bancrits = bancrits .. "\n\n" .. cWhite .. key .. cGold
		end
	else
	
		for key, value in pairs(LediiData[char_name][CRITS_BAN2]) do
			bancrits = bancrits .. "\n\n" .. cWhite .. key .. cGold
		end

	end
	
	MyFrame.text:SetText(cGold .. bancrits)
end

function Ledii_HandleEvents(self, event, ...)
	char_name = GetRealmName() .. " - " .. UnitName("Player")
	
	-- Player login:
	if (event == "PLAYER_LOGIN") then
		print(prefix .. "Version " .. version .. " loaded!")
		boot = true
		
		if (LediiData == nil) then
			LediiData = {}
		end
		if (LediiData[char_name] == nil) then
			LediiData[char_name] = {}
			print(prefix .. "Created first-time data for " .. char_name)			
		end
		if (LediiData[char_name][CRITS_DMG] == nil) then
			LediiData[char_name][CRITS_DMG] = {}
		end
		if (LediiData[char_name][CRITS_HEAL] == nil) then
			LediiData[char_name][CRITS_HEAL] = {}
		end
		if (LediiData[char_name][CRITS_DMG2] == nil) then
			LediiData[char_name][CRITS_DMG2] = {}
		end
		if (LediiData[char_name][CRITS_HEAL2] == nil) then
			LediiData[char_name][CRITS_HEAL2] = {}
		end
		if (LediiData[char_name][CRITS_BAN1] == nil) then
			LediiData[char_name][CRITS_BAN1] = {}
		end
		if (LediiData[char_name][CRITS_BAN2] == nil) then
			LediiData[char_name][CRITS_BAN2] = {}
		end
		
		print(prefix .. "Type " .. cWhite .. "/critz help" .. cGold .. " to show the list of commands.")
	
		-- Statistics:
		MyFrame = CreateFrame("Frame", "DragFrame2", UIParent)
		MyFrame:ClearAllPoints()
		MyFrame:SetBackdrop(StaticPopup1:GetBackdrop())
		MyFrame:SetHeight(700)
		MyFrame:SetWidth(300)
		MyFrame:SetMovable(true)
		MyFrame:EnableMouse(true)
		MyFrame:RegisterForDrag("LeftButton")
		MyFrame:SetScript("OnDragStart", MyFrame.StartMoving)
		MyFrame:SetScript("OnDragStop", MyFrame.StopMovingOrSizing)
		MyFrame:SetPoint("CENTER", 0, 0)
		MyFrame:Hide(true)
		
		MyFrame.text = MyFrame:CreateFontString(nil, "BACKGROUND", "GameFontNormal")
		MyFrame.text:SetPoint("TOPLEFT", 30, -30);
		MyFrame.text:SetJustifyH("LEFT")
		Update_Crits()
	end
	
	if (event == "ACTIVE_TALENT_GROUP_CHANGED" and boot == true) then
		Update_Crits()
	end
end

function Combat_Log(timestamp, event, hideCaster, sourceGUID, sourceName, sourceFlags, source, destGUID, destName, destFlags, target, arg1, arg2, arg3, ability, arg5, damage, overkill, arg8, ...)
	if (damage ~= nil) then
		local abilitytext = cWhite .. ability .. cGold
		local damagetext = cRed .. damage .. cGold
		local healtext = cGreen .. damage .. cGold
		local spec = GetActiveSpecGroup()
		local banned = false
		
		if (spec == 1) then
			for key, value in pairs(LediiData[char_name][CRITS_BAN1]) do
				if (key == ability) then
					banned = true
				end
			end
			if (banned == false) then
				if ((sourceGUID == "SWING_DAMAGE") or (sourceGUID == "RANGE_DAMAGE") or (sourceGUID == "SPELL_DAMAGE") or (sourceGUID == "SPELL_PERIODIC_DAMAGE") or (sourceGUID == "SPELL_BUILDING_DAMAGE")) then
					if ((LediiData[char_name][CRITS_DMG][ability] == nil) or (LediiData[char_name][CRITS_DMG][ability] < damage)) then
						RaidNotice_AddMessage(RaidWarningFrame, prefix .. "New record for " .. abilitytext .. " is " .. damagetext .. "!", ChatTypeInfo["RAID_WARNING"])
						print(prefix .. "New record for " .. abilitytext .. " is " .. damagetext .. "!")
						LediiData[char_name][CRITS_DMG][ability] = damage
						if (banmode == false) then
							Update_Crits()
						end
					end
				elseif ((sourceGUID == "SWING_HEAL") or (sourceGUID == "RANGE_HEAL") or (sourceGUID == "SPELL_HEAL") or (sourceGUID == "SPELL_PERIODIC_HEAL") or (sourceGUID == "SPELL_BUILDING_HEAL")) then
					if ((LediiData[char_name][CRITS_HEAL][ability] == nil) or (LediiData[char_name][CRITS_HEAL][ability] < damage)) then
						RaidNotice_AddMessage(RaidWarningFrame, prefix .. "New record for " .. abilitytext .. " is " .. healtext .. "!", ChatTypeInfo["RAID_WARNING"])
						print(prefix .. "New record for " .. abilitytext .. " is " .. healtext .. "!")
						LediiData[char_name][CRITS_HEAL][ability] = damage
						if (banmode == false) then
							Update_Crits()
						end
					end
				end
			end
		else
			for key, value in pairs(LediiData[char_name][CRITS_BAN2]) do
				if (key == ability) then
					banned = true
				end
			end
			if (banned == false) then
				if ((sourceGUID == "SWING_DAMAGE") or (sourceGUID == "RANGE_DAMAGE") or (sourceGUID == "SPELL_DAMAGE") or (sourceGUID == "SPELL_PERIODIC_DAMAGE") or (sourceGUID == "SPELL_BUILDING_DAMAGE")) then
					if ((LediiData[char_name][CRITS_DMG2][ability] == nil) or (LediiData[char_name][CRITS_DMG2][ability] < damage)) then
						RaidNotice_AddMessage(RaidWarningFrame, prefix .. "New record for " .. abilitytext .. " is " .. damagetext .. "!", ChatTypeInfo["RAID_WARNING"])
						print(prefix .. "New record for " .. abilitytext .. " is " .. damagetext .. "!")
						LediiData[char_name][CRITS_DMG2][ability] = damage
						if (banmode == false) then
							Update_Crits()
						end
					end
				elseif ((sourceGUID == "SWING_HEAL") or (sourceGUID == "RANGE_HEAL") or (sourceGUID == "SPELL_HEAL") or (sourceGUID == "SPELL_PERIODIC_HEAL") or (sourceGUID == "SPELL_BUILDING_HEAL")) then
					if ((LediiData[char_name][CRITS_HEAL2][ability] == nil) or (LediiData[char_name][CRITS_HEAL2][ability] < damage)) then
						RaidNotice_AddMessage(RaidWarningFrame, prefix .. "New record for " .. abilitytext .. " is " .. healtext .. "!", ChatTypeInfo["RAID_WARNING"])
						print(prefix .. "New record for " .. abilitytext .. " is " .. healtext .. "!")
						LediiData[char_name][CRITS_HEAL2][ability] = damage
						if (banmode == false) then
							Update_Crits()
						end
					end
				end
			end
		end
	end
	
end


-- Chat commands:
SLASH_CRITZ1 = "/critz"
function SlashCmdList.CRITZ(msg, editbox)
	if (msg == "") then
		if (MyFrame:IsShown() == nil) then
			MyFrame:Show(true)
			banmode = false
			Update_Crits()
		else
			MyFrame:Hide(true)
			banmode = false
		end
	elseif (msg == "help") then
		print(prefix .. cWhite .. "/critz" .. cGold .. " - Show/Hide data for CritZ.")
		print(prefix .. cWhite .. "/critz banned" .. cGold .. " - Toggle list of banned abilities.")
		print(prefix .. cWhite .. "/clearcritz [Ability]" .. cGold .. " - Removes data for the given [Ability]. (All if empty!)")
		print(prefix .. cWhite .. "/bancritz [Ability]" .. cGold .. " - Bans the given ability. (Will no longer be registered!)")
		print(prefix .. cWhite .. "/unbancritz [Ability]" .. cGold .. " - Unbans the given ability. (Will register new data!)")
	elseif (msg == "banned") then
		if (MyFrame:IsShown() == nil) then
			MyFrame:Show(true)
			banmode = true
			Update_Bans()
		else
			if (banmode == false) then
				banmode = true
				Update_Bans()
			else
				banmode = false
				Update_Crits()
			end
		end
	else
		print(prefix .. "Type " .. cWhite .. "/critz help" .. cGold .. " to show the list of commands.")
	end
end

SLASH_CLEARCRITZ1 = "/clearcritz"
function SlashCmdList.CLEARCRITZ(msg, editbox)
	local spec = GetActiveSpecGroup()
	
	if (msg == "") then
		if (spec == 1) then
			LediiData[char_name][CRITS_DMG] = nil
			LediiData[char_name][CRITS_HEAL] = nil
		else
			LediiData[char_name][CRITS_DMG2] = nil
			LediiData[char_name][CRITS_HEAL2] = nil
		end
		Update_Crits()
		print(prefix .. "Cleared all data!")
	else
		local found = false
		if (spec == 1) then
			if (LediiData[char_name][CRITS_DMG][msg] ~= nil) then
				LediiData[char_name][CRITS_DMG][msg] = nil
				found = true
			end
			if (LediiData[char_name][CRITS_HEAL][msg] ~= nil) then
				LediiData[char_name][CRITS_HEAL][msg] = nil
				found = true
			end
		else
			if (LediiData[char_name][CRITS_DMG2][msg] ~= nil) then
				LediiData[char_name][CRITS_DMG2][msg] = nil
				found = true
			end
			if (LediiData[char_name][CRITS_HEAL2][msg] ~= nil) then
				LediiData[char_name][CRITS_HEAL2][msg] = nil
				found = true
			end
		end
		if (found == true) then
			Update_Crits()
			print(prefix .. "Cleared data for " .. cWhite .. "'" .. msg .. "'" .. cGold .. "!")
		else
			print(prefix .. "No data found for " .. cWhite .. "'" .. msg .. "'" .. cGold .. "!")
		end
	end
end

SLASH_BANCRITZ1 = "/bancritz"
function SlashCmdList.BANCRITZ(msg, editbox)
	local spec = GetActiveSpecGroup()
	
	if (msg == "") then
		print(prefix .. "You need to type in an ability to ban!")
	else
		if (spec == 1) then
			LediiData[char_name][CRITS_BAN1][msg] = true
		else
			LediiData[char_name][CRITS_BAN2][msg] = true
		end
		print(prefix .. "Banned ability " .. cWhite .. "'" .. msg .. "'" .. cGold .. "!")
		SlashCmdList.CLEARCRITZ(msg, editbox)
	end
end

SLASH_UNBANCRITZ1 = "/unbancritz"
function SlashCmdList.UNBANCRITZ(msg, editbox)
	local spec = GetActiveSpecGroup()
	
	if (msg == "") then
		if (spec == 1) then
			LediiData[char_name][CRITS_BAN1] = nil
		else
			LediiData[char_name][CRITS_BAN2] = nil
		end
		print(prefix .. "All abilities are now unbanned!")
	else
		local found = false
		if (spec == 1) then
			if (LediiData[char_name][CRITS_BAN1][msg] ~= nil) then
				LediiData[char_name][CRITS_BAN1][msg] = nil
				found = true
			end
		else
			if (LediiData[char_name][CRITS_BAN2][msg] ~= nil) then
				LediiData[char_name][CRITS_BAN2][msg] = nil
				found = true
			end
		end
		if (found == true) then
			if (banmode == true) then
				Update_Bans()
			end
			print(prefix .. "Unbanned ability " .. cWhite .. "'" .. msg .. "'" .. cGold .. "!")
		else
			print(prefix .. "Cound not find ability " .. cWhite .. "'" .. msg .. "'" .. cGold .. "!")
		end
	end
end


-- Events to register:
PlayerEvent:RegisterEvent("PLAYER_LOGIN")
PlayerEvent:RegisterEvent("ACTIVE_TALENT_GROUP_CHANGED")
PlayerEvent:SetScript("OnEvent", Ledii_HandleEvents)

CombatLogEvent:RegisterEvent("COMBAT_LOG_EVENT")
CombatLogEvent:SetScript("OnEvent", Combat_Log)